/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2008 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(__PROCESSOR_H)
#define __PROCESSOR_H

bool startProcessorStatistics(bool bisWinNT, bool bisWin2K);
int getProcessorUsage(string processName = "");
bool endProcessorStatistics();

static HANDLE hThread;
static void Update();
static UINT __stdcall ThreadProc(LPVOID pvThis);

class CCpuUsage
{
	public:
		CCpuUsage();
		virtual ~CCpuUsage();

	// Methods
		int GetCpuUsage();
		int GetCpuUsage(LPCTSTR pProcessName);
		//int GetCpuUsage(DWORD dwProcessID);

		BOOL EnablePerformaceCounters(BOOL bEnable = TRUE);

	// Attributes
	private:
		bool			m_bFirstTime;
		LONGLONG		m_lnOldValue ;
		LARGE_INTEGER	m_OldPerfTime100nSec;
	
};

#endif
